module Svnlog2csv

  # Una LogEntry corrisponde ad un commit.
  # Un commit è caratterizzato da una data, un autore e una serie di azioni.
  # Ogni azione è un hash con la struttura {tipo_azione: n},
  # dove tipo_azione può essere A (add), M (modify), D (delete), e n è il
  # numero di file aggiunti/modificati/cancellati.
  class LogEntry

    attr_reader :day, :author, :actions

    def initialize xml
      doc      = Nokogiri::XML(xml)
      @day     = doc.xpath("//date")[0].inner_text[0..9]
      @author  = doc.xpath("//author")[0].inner_text
      @actions = Hash.new(0)
      doc.xpath("//path").each do |path|
        @actions[path.attribute("action").value.to_sym] += 1
      end
    end

  end

end