module Svnlog2csv

  # Classe di utilità che sfrutta nokogiri per leggere dati xml
  class Reader

    NODE_TYPE = Nokogiri::XML::Reader::TYPE_ELEMENT

    def initialize string_or_io
      @reader = Nokogiri::XML::Reader(string_or_io) 
    end

    def each node_name = nil
      @reader.each do |node|
        if node_name.nil? || (node.name == node_name && node.node_type == NODE_TYPE)
          yield node
        end
      end
    end

    # Estrae dall'xml tutti gli autori dei commit.
    def authors
      list = []
      each("author") do |node|
        author = node.inner_xml
        unless list.include?(author)
          list << author
        end
      end
      list
    end

  end

end